#include "ui_table.h"

#include <Fl.H>
#include <fl_draw.H>

UITable::UITable(int x, int y, int w, int h):Fl_Table(x, y, w, h){
	_data = 0;
}
UITable::~UITable(){

}
void UITable::set_data(char **data, int numrows, int numcols){
	_data = data;
	rows(numrows);
	cols(numcols);
}
bool UITable::add_col(char **col, int numrows){
	if (numrows > 0 && numrows <= rows()){

	}
}
bool UITable::add_row(char **row, int numcols){
	if (numcols > 0 && numcols <= cols()){
		
	}
}
bool UITable::set_cell(char *cell, int col, int row){
	if (col >= 0 && col < cols()){
		if (row >= 0 && row < rows()){
			memcpy(&_data[row][col], cell, strlen(cell));
			return true;
		}
	}
	return false;
}
void UITable::clear(){

}
void UITable::cols(int numcols){
	
	Fl_Table::cols(numcols);
}
int UITable::cols(){
	return Fl_Table::cols();
}
void UITable::rows(int numrows){

	Fl_Table::rows(numrows);
}
int UITable::rows(){
	return Fl_Table::rows();
}

void UITable::draw_cell(TableContext context, int R = 0, int C = 0, int X = 0, int Y = 0, int W = 0, int H = 0){
	switch ( context ) {
        case CONTEXT_STARTPAGE:             // Fl_Table telling us its starting to draw page
            fl_font(FL_HELVETICA, 16);
            return;
       
        //case CONTEXT_ROW_HEADER:            // Fl_Table telling us it's draw row/col headers
        case CONTEXT_COL_HEADER:
            fl_push_clip(X, Y, W, H);
            {
                fl_draw_box(FL_THIN_UP_BOX, X, Y, W, H, color());
                fl_color(FL_BLACK);
				switch (C){
					case 0:
						fl_draw("Num", X, Y, W, H, FL_ALIGN_CENTER);
						break;
					case 1:
						fl_draw("Name", X, Y, W, H, FL_ALIGN_CENTER);
						break;
					case 2:
						fl_draw("Size", X, Y, W, H, FL_ALIGN_CENTER);
						break;
					case 3:
						fl_draw("Part", X, Y, W, H, FL_ALIGN_CENTER);
						break;
				}
                //
            }
            fl_pop_clip();
            return;
           
        case CONTEXT_CELL:                  // Fl_Table telling us to draw cells
            fl_push_clip(X, Y, W, H);
            {
                // BG COLOR
                fl_color( row_selected(R) ? selection_color() : FL_WHITE);
                fl_rectf(X, Y, W, H);
                   
                // TEXT
                fl_color(FL_BLACK);
				switch (C){
					case 0:
						fl_draw(_list[R].idx, X, Y, W, H, FL_ALIGN_CENTER);
						break;
					case 1:
						fl_draw(_list[R].name, X + 5, Y, W - 10, H, FL_ALIGN_LEFT);
						break;
					case 2:
						fl_draw(_list[R].size, X + 5, Y, W - 10, H, FL_ALIGN_LEFT);
						break;
					case 3:
						fl_draw(_list[R].part_count, X, Y, W, H, FL_ALIGN_CENTER);
						break;
				}
                   
                // BORDER
                fl_color(FL_LIGHT2);
                fl_rect(X, Y, W, H);
            }
            fl_pop_clip();
            return;
           
    default:
        return;
    }
}